/*
 * =====================================================================================
 *
 *       Filename:  vect_test.cpp
 *
 *    Description:  :
 *
 *        Version:  1.0
 *        Created:  06/19/2011 10:21:04 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ruben Safir (), ruben@mrbrklyn.com
 *        Company:  NYLXS
 *
 * =====================================================================================
 */
// constructing vectors
#include <iostream>
#include <vector>
using namespace std;

int main ()
{
	unsigned int i;

	// constructors used in the same order as described above:
	vector<int> first;                                // empty vector of ints
	vector<int> second (4,100);                       // four ints with value 100
	vector<int> third (second.begin(),second.end());  // iterating through second
	vector<int> fourth (third);                       // a copy of third

	// the iterator constructor can also be used to construct from arrays:
	int myints[] = {16,2,77,29};
	vector<int> fifth (myints, myints + sizeof(myints) / sizeof(int) );

	cout << sizeof(myints) << " " << sizeof(int) << endl;
	cout << "The contents of fifth are:";
	for (i=0; i < fifth.size(); i++)
		cout << " " << fifth[i];

	cout << endl;

	return 0;
}
